// Point3DArray.cpp: implementation of the CPoint3DArray class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ptlist.h"
#include "Point3DArray.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPoint3DArray::CPoint3DArray()
{
	Visible = true;
}

CPoint3DArray::CPoint3DArray(const CPoint3DArray& Src)
{
	*this = Src;
}

CPoint3DArray::~CPoint3DArray()
{

}

CPoint3DArray& CPoint3DArray::operator=( const CPoint3DArray& Src )
{
	RemoveAll();
	Visible = Src.Visible;
	Name = Src.Name;
	for( int i=0; i < Src.GetSize(); i++ )
		Add( Src.GetAt(i));
	return(*this);
}

void CPoint3DArray::Serialize(CArchive& ar)
{
	
	if( ar.IsStoring() )
	{
		ar << Name;
		int i= Visible?1:0;
		ar.Write(&i, sizeof(i));
		i=GetSize();
		ar.Write(&i, sizeof(i));
		for( i=0; i < GetSize(); i++ )
			GetAt(i).Serialize(ar);
	}
	else
	{
		CPoint3D Tmp;
		int i, j;
		RemoveAll();
		ar >> Name;
		ar.Read(&i, sizeof(i));
		Visible = (i==1);
		ar.Read(&i, sizeof(i));
		for( j=0; j < i; j++ )
		{
			Tmp.Serialize(ar);
			Add( Tmp );
		}
	}
}

/*template <class CPoint3DArray> void AFXAPI SerializeElements<CPoint3DArray> ( CArchive& ar, CPoint3DArray* pElements, int nCount )
{
    for ( int i = 0; i < nCount; i++)
        pElements[i].Serialize( ar );
}
*/
