// VisibleDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ptlist.h"
#include "VisibleDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisibleDialog dialog


CVisibleDialog::CVisibleDialog(CFrame* pFrame, CWnd* pParent /*=NULL*/)
	: CDialog(CVisibleDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVisibleDialog)
	//}}AFX_DATA_INIT

	Frame = pFrame;	// MG: Store data member to CFrame (from document, to view, to here)
}


void CVisibleDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVisibleDialog)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVisibleDialog, CDialog)
	//{{AFX_MSG_MAP(CVisibleDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisibleDialog message handlers

BOOL CVisibleDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// MG: Determine position, based on a 
	//     'place-holder' static control in the dialog
	RECT X;
	GetDlgItem( IDC_CHECKPOS )->GetWindowRect( &X );
	ScreenToClient( &X );
	
	// MG: Create the CCheckListBox, using size and position just determined
	CheckVisible.Create( 
		LBS_SORT|LBS_HASSTRINGS|LBS_OWNERDRAWFIXED|WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_BORDER, 
		X, this, 200);

	// MG: Initialize the CCheckListBox items, with or w/o checks
	int j;
	for( int i=0; i < Frame->GetSize(); i++ )
	{
		j = CheckVisible.AddString( Frame->GetAt(i).Name );
		CheckVisible.SetCheck( j, Frame->GetAt(i).Visible );
		CheckVisible.SetItemData( j, i ); // MG: Store Index in 'Data'
	}
		
	CheckVisible.ShowWindow( SW_NORMAL ); // MG: Show the Check list

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CVisibleDialog::OnOK() 
{
	// MG: The OK button updates the CFrame object directly here, if the
	//     user clicked OK.  The view that invoked it must simply
	//     call the UpdateAllViews function for it's document.
	int Checked, Index;
	for( int i=0; i < CheckVisible.GetCount(); i++ )
	{
		Checked = CheckVisible.GetCheck( i );
		Index = CheckVisible.GetItemData(i);
		// MG: Note that GetAt won't work here, because it returns an object, not a reference
		(*Frame)[Index].Visible = (Checked!=0);
	}
	
	CDialog::OnOK();
}
