// ptlistView.cpp : implementation of the CPtlistView class
//

#include "stdafx.h"
#include "ptlist.h"

#include "ptlistDoc.h"
#include "ptlistView.h"

#include "VisibleDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPtlistView

IMPLEMENT_DYNCREATE(CPtlistView, CView)

BEGIN_MESSAGE_MAP(CPtlistView, CView)
	//{{AFX_MSG_MAP(CPtlistView)
	ON_COMMAND(IDM_IMPORT, OnImport)
	ON_COMMAND(ID_VIEW_VISIBLE, OnViewVisible)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPtlistView construction/destruction

CPtlistView::CPtlistView()
{
	// TODO: add construction code here

}

CPtlistView::~CPtlistView()
{
}

BOOL CPtlistView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPtlistView drawing

void CPtlistView::OnDraw(CDC* pDC)
{
	CPtlistDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	for( int F = 0; F < pDoc->Frame.GetSize(); F++ )
	{
		if( pDoc->Frame.GetAt(F).Visible )
			for( int S = 0; S< pDoc->Frame.GetAt(F).GetSize(); S++ )
			{
				if( S==0 )
					pDC->MoveTo( pDoc->Frame.GetAt(F).GetAt(S).X, 
				             pDoc->Frame.GetAt(F).GetAt(S).Y);
				else
					pDC->LineTo( pDoc->Frame.GetAt(F).GetAt(S).X, 
				             pDoc->Frame.GetAt(F).GetAt(S).Y);
			}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPtlistView printing

BOOL CPtlistView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPtlistView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPtlistView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPtlistView diagnostics

#ifdef _DEBUG
void CPtlistView::AssertValid() const
{
	CView::AssertValid();
}

void CPtlistView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPtlistDoc* CPtlistView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPtlistDoc)));
	return (CPtlistDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPtlistView message handlers

void CPtlistView::OnImport() 
{
	// MG: Handles the import from a file
	CPtlistDoc* pDoc = GetDocument();
	
	// MG: Establish a file-open dialog box
	CFileDialog Open( TRUE, "dat", "*.dat", 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Dat files;*.DAT||All files;*.*", this );
	
	if( Open.DoModal() == IDOK )
	{
		CFile Input;
		
		// MG: Eliminate old data
		pDoc->Frame.RemoveAll();
		if( Input.Open( Open.GetPathName(), CFile::modeRead ) )
		{
			char *InputData, *Tmp, *Line;
			DWORD FileSize = Input.GetLength();
			CPoint3D Point;
			CString PointInfo;
			int FrameIndex=-1, Comma1, Comma2;
			CPoint3DArray PointArray;

			// MG: Read entire file into memory in 1 read
			Tmp = InputData = new char[FileSize+1];
			Input.Read( InputData, FileSize );
			InputData[FileSize]='\0';
			while( (Line=strtok( Tmp, "\n" )) ) // MG: Parse it on \n
			{
				Tmp=NULL;
				if( *Line=='[' ) // MG: In my example, indicates a new shape (list of points)
				{
					if( FrameIndex>=0 )
					{
						pDoc->Frame.Add( PointArray );
						PointArray.RemoveAll();
					}
					FrameIndex++;
					Line[strlen(Line)-2] = '\0';
					PointArray.Name = Line+1;				
				}
				else
				{
					// MG: Point data, 3 integers
					if( strlen(Line)>1 )
					{
						PointInfo = Line;
						Comma1 = PointInfo.Find( ',');
						Comma2 = PointInfo.ReverseFind( ',');
						Point.X = atoi( PointInfo.Left(Comma1 ) );
						Point.Y = atoi( PointInfo.Mid(Comma1+1, Comma2-Comma1));
						Point.Z = atoi( PointInfo.Right(Comma2+1) );
						PointArray.Add( Point );
					}
				}
			}
			// MG: Add the last point array, and set document 'dirty'
			pDoc->Frame.Add( PointArray );
			delete [] InputData;
			pDoc->SetModifiedFlag( TRUE );
			pDoc->UpdateAllViews(NULL);
		}
	}

}

void CPtlistView::OnViewVisible() 
{
	// MG: Invoke dialog box to select visible/invisible items
	CPtlistDoc* pDoc = GetDocument();
	CVisibleDialog Tmp( &pDoc->Frame );

	if( Tmp.DoModal()==IDOK )
		pDoc->UpdateAllViews(NULL);
}
